"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _debounce = _interopRequireDefault(require("../debounce"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
const withScrollEndEvent = Component => {
  const Wrapper = ({
    onScrollEnd: onScrollEndProp = () => {},
    onScrollEndDrag: onScrollEndDragProp,
    onMomentumScrollBegin: onMomentumScrollBeginProp,
    onMomentumScrollEnd: onMomentumScrollEndProp,
    ...rest
  }, forwardedRef) => {
    const onScrollEnd = (0, _react.useMemo)(() => (0, _debounce.default)(onScrollEndProp, 0),
    // This works well with onScrollEndDrag -> onMomentumScrollBegin transitions
    [onScrollEndProp]);
    const onScrollEndDrag = (0, _react.useCallback)(args => {
      onScrollEndDragProp === null || onScrollEndDragProp === void 0 || onScrollEndDragProp(args);
      onScrollEnd();
    }, [onScrollEnd, onScrollEndDragProp]);
    const onMomentumScrollBegin = (0, _react.useCallback)(args => {
      onScrollEnd.clear();
      onMomentumScrollBeginProp === null || onMomentumScrollBeginProp === void 0 || onMomentumScrollBeginProp(args);
    }, [onScrollEnd, onMomentumScrollBeginProp]);
    const onMomentumScrollEnd = (0, _react.useCallback)(args => {
      onMomentumScrollEndProp === null || onMomentumScrollEndProp === void 0 || onMomentumScrollEndProp(args);
      onScrollEnd();
    }, [onScrollEnd, onMomentumScrollEndProp]);
    return /*#__PURE__*/_react.default.createElement(Component, _extends({}, rest, {
      ref: forwardedRef,
      onScrollEndDrag: onScrollEndDrag,
      onMomentumScrollBegin: onMomentumScrollBegin,
      onMomentumScrollEnd: onMomentumScrollEnd
    }));
  };
  Wrapper.displayName = `withScrollEndEvent(${Component.displayName || 'Component'})`;
  return /*#__PURE__*/(0, _react.memo)(/*#__PURE__*/(0, _react.forwardRef)(Wrapper));
};
var _default = exports.default = withScrollEndEvent;
//# sourceMappingURL=withScrollEndEvent.js.map