import React from 'react';
import type { TextStyle } from 'react-native';
import { StyleProp, ViewStyle } from 'react-native';
import type { KeyExtractor, OnValueChanged, OnValueChanging, PickerItem, RenderItem, RenderItemContainer, RenderList, RenderOverlay } from '../types';
export type PickerProps<ItemT extends PickerItem<any>> = {
    data: ReadonlyArray<ItemT>;
    value?: ItemT['value'];
    itemHeight?: number;
    visibleItemCount?: number;
    width?: number | 'auto' | `${number}%`;
    readOnly?: boolean;
    testID?: string;
    onValueChanging?: OnValueChanging<ItemT>;
    onValueChanged?: OnValueChanged<ItemT>;
    keyExtractor?: KeyExtractor<ItemT>;
    renderItem?: RenderItem<ItemT>;
    renderItemContainer?: RenderItemContainer<ItemT>;
    renderOverlay?: RenderOverlay | null;
    renderList?: RenderList<ItemT>;
    style?: StyleProp<ViewStyle>;
    itemTextStyle?: StyleProp<TextStyle>;
    overlayItemStyle?: StyleProp<ViewStyle>;
    contentContainerStyle?: StyleProp<ViewStyle>;
    scrollEventThrottle?: number;
};
declare const Picker: <ItemT extends PickerItem<any>>({ data, value, width, itemHeight, visibleItemCount, readOnly, testID, onValueChanged, onValueChanging, keyExtractor, renderItem, renderItemContainer, renderOverlay, renderList, style, itemTextStyle, overlayItemStyle, contentContainerStyle, ...restProps }: PickerProps<ItemT>) => React.JSX.Element;
export default Picker;
//# sourceMappingURL=Picker.d.ts.map